use strict;
use warnings;

sub validate_commandline_args {

    # Purpose: validate command line arguments
    #
    # Input parameters:
    #   $ncpu     - number of CPUs
    #   $nodefile - file containing list of nodes
    #
    # Return values:
    #   None

    my ($ncpu, $nodefile, $param_file) = @_;
    unless(defined $ncpu) {
	print "Need to specify number of nodes\n";
	exit;
    }
    unless($ncpu =~ /^\d+$/) {
	print "$ncpu is not a valid choice for number of nodes\n";
	exit;
    }
    unless(defined $nodefile) {
	print "Need to specify node file\n";
	exit;
    }
    unless(defined $param_file) {
	print "Need to specify parameter file\n";
	exit;
    }
    unless( -r $param_file) {
	print "Parameter file $param_file is not readable\n";
	exit;
    }

    # May want to add tests to confirm that the nodefile can be opened
    # and contains the proper number of lines

}
1;
