      PROGRAM P3Dsf
      implicit none
      
      include 'mpif.h'
      INCLUDE '../include/allprogs.inc'
      INCLUDE '../include/info.inc'
      include '../include/com_01.inc'
      include '../include/mem_time.inc'
      
      Character(len=4) :: subname  = '    '
      
C     Local variables, used only in the main routine
      real center(2)

      logical :: confine_3D = .false.
      logical :: first
      
      integer first_iq, last_iq, max_iq_slab, max_node_eqns,
     +     first_z,last_z, first_hk,last_hk, max_hk_slab, num_hkl,
     +     den_min_x, den_max_x, den_min_y, den_max_y,
     +     den_min_z, den_max_z, node, mem_size,
     +     min_xyz, max_xyz, hkl_min, hkl_max, max_z_slab,
     +     first_rr_out, last_rr_out, max_rr_out_slab,
     +     first_u, last_u, max_u_slab,
     +     first_y, last_y, max_y_slab,
     +     interpolants_size
      
      integer nrffts_1_row, nrffts_1_col, nrffts_1_omega,
     +     nrffts_2_row, nrffts_2_col, nrffts_2_omega,
     +     max_axis

      integer npix_col_even, npix_row_even, npix_col_odd, npix_row_odd
      real pixsize_even, pixsize_odd

      logical iam_continues_cmpt_intrps,
     +     iam_continues_solve_fftsynth_1,
     +     iam_continues_fftsynth_2
      
      real, allocatable :: map3d(:), rffta_omega(:)
      real  mapprjbig

      complex, allocatable :: f_hkl_1(:),f_hkl_2(:),fft3d(:),fft_klh(:)
    
      character*(filename_len) fileeven, fileodd
      real  tmp1, tmp2, tmp4, max_annul
      integer imax_annul, i, tmp3
      integer alloc_stat, ierr
      
C     *********************************************************************
C     *                      Initialization                               *
C     *********************************************************************
      test_time   = .true.
      test_memory = .true.
      call usage
      progname = 'Psf '
      
      call MPI_INIT ( mpi_err )
      if (mpi_err.ne.0) call error_stop(progname, subname, 
     +     'Error in MPI_INIT')
      call MPI_COMM_RANK ( MPI_COMM_WORLD, iam, mpi_err )
      if (mpi_err.ne.0) call error_stop(progname, subname, 
     +     'Error in MPI_COMM_RANK')
      call MPI_COMM_SIZE ( MPI_COMM_WORLD, num_nodes, mpi_err )
      if (mpi_err.ne.0) call error_stop(progname, subname, 
     +     'Error in MPI_COMM_SIZE')
      if (num_nodes .gt. max_numnodes) then
         write(stdoutput, 9001) num_nodes, max_numnodes
 9001    format(//' Requested number of nodes = NUM_NODES    = ',i10/
     +        ' Available number of nodes = MAX_NUMNODES = ',i10/)
         call error_stop(progname, subname,
     +        'NUM_NODES requested exceeds MAX_NUMNODES')
      endif
      
      t1 = wtime()
      if ( iam.eq. 0) then
         print *, ' Number of Nodes = ', num_nodes
         
         READ (*,'(A)') fileeven
         WRITE(*,'(2A)') 'Even map FILENAME: ', fileeven
         READ (*,'(A)') fileodd
         WRITE(*,'(2A)') 'Odd map FILENAME: ', fileodd

         call get_map_dimensions(fileeven, npix_col_even, npix_row_even,
     $        pixsize_even, ierr)
         if(ierr .gt. 0) then
            call error_stop('PSF', 'PSF',
     +           'Error in even 3D map mode, it should be 20 or 40')
         endif
         
         call get_map_dimensions(fileodd, npix_col_odd, npix_row_odd,
     $        pixsize_odd, ierr)
         if(ierr .gt. 0) then
            call error_stop('PSF', 'PSF',
     +           'Error in odd 3D map mode, it should be 20 or 40')
         endif

         if ( npix_col_even .ne. npix_col_odd .or.
     $        npix_row_even .ne. npix_row_odd .or.
     +        abs(pixsize_odd - pixsize_even) .gt. 10E-6) then
            call error_stop('PSF', 'PSF',
     +           'Two 3D density map have different size!')
         else
            npix_col = npix_col_even
            npix_row = npix_row_even
            angstrom_per_pix = pixsize_even
         endif

         read(*,*) tmp1, tmp2, tmp3, tmp4
         if (TMP1.GE.TMP2.or.TMP1.lt.2*TMP4.or.TMP3.le.0.) then
            call error_stop(progname, subname,
     +           'Input parameters tmp1 through tmp 4 not correct')
         endif

C     --------------------------------------------------------------------
         Res_min   = TMP2 
         Res_max   = TMP1 
         Nangle    = TMP3 
         zero_fill = 1.0
         NFILES    = 1
         mapmagfactor = 1.0 
         PIXSIZ_OUT   = TMP4 
         if (abs(angstrom_per_pix - PIXSIZ_OUT) .ge. 10E-5) 
     +        print *, 
     +        'Warning: the map pixel size is not same as input',
     +        angstrom_per_pix, PIXSIZ_OUT
         PRINT *, 'RES_HI,RES_LOW,RES_STEP,PIXEL_SIZE:',
     +        Res_max, Res_min, Nangle, PIXSIZ_OUT
      endif
C     --------------------------------------------------------------------
      
      if( num_nodes .gt. 1 ) then
C     CALL BCAST_PARAMETERS
C     *******************************
C     Broadcast User's parameters and PIF File Header to other nodes.
         call bcast_parameters 

      endif
C     CALL INTLZ_PARAMS
C     *****************
      call intlz_params(hkl_min, hkl_max, num_hkl, min_xyz, max_xyz, 
     +     nrffta_row, nrffta_col, nrffta_omega, nfc_2d_row, 
     +     nfc_2d_col, nrffts_1_row, nrffts_1_col, 
     +     nrffts_1_omega, nrffts_2_row, nrffts_2_col, 
     +     nrffts_2_omega, den_min_x, den_max_x, den_min_y, 
     +     den_max_y, den_min_z, den_max_z,
     +     confine_3D,
     +     max_axis )
      
Cji 01/06/01 added 2 print statements after call of intlz_params
      if( iam .eq. 0 ) then
         print *, ' zero_fill after  call of INTLZ_PARAMS =',zero_fill
         print *, ' nrffta_row after call of INTLZ_PARAMS =',nrffta_row
      endif
C     CALL INTLZ_ARRAYS
C     *****************
      call intlz_arrays( hkl_min, hkl_max, min_xyz, max_xyz,
     +     min_y, max_y, min_z, max_z, max_views, num_symm,
     +     first_hk, last_hk, max_hk_slab, first_iq, last_iq,
     +     max_iq_slab, first_rr_out, last_rr_out, max_rr_out_slab,
     +     first_u, last_u, max_u_slab, first_view, last_view,
     +     first_y, last_y, max_y_slab, first_z, last_z, max_z_slab,
     +     max_node_eqns, npix_row,
     +     iam_continues_cmpt_intrps,
     +     iam_continues_solve_fftsynth_1, iam_continues_fftsynth_2)

C ---------- End of Initializationl --- Synchronize all the nodes ------

      call mpi_barrier(mpi_comm_world, mpi_err)
      t2 = wtime()
      t_init = t2 - t1
      
C     **********************************************************************
C     *             3D DFT of input 3D density map                         *
C     **********************************************************************
      allocate(rffta_omega(nrffta_omega), stat = alloc_stat)
      if(alloc_stat .gt. 0) call error_stop (progname, subname,
     +     'Error in allocating memory for nrffta_omega')
      
      call vrffti( nrffta_col, rffta_omega )

      max_annul = real(nrffta_row)*PIXSIZ_OUT/res_max
      imax_annul = min(int(max_annul)+1,hkl_max)
      
      in_3d_name = fileeven
      first = .true.
      
 400  mem_size = npix_col * npix_row * max_y_slab
      allocate(map3d(mem_size), stat = alloc_stat)
      mem_map3d = dble(4 * mem_size) 
      if (alloc_stat .gt. 0) call error_stop (progname, subname,
     +     '3D density map memory allocation failed')
      mem_total = mem_total + mem_map3d
      mem_peak  = max(mem_peak, mem_total)
      
      call read_map(in_3d_name, map3d, npix_col, npix_row,
     +     max_ y_slab, mapprjbig)

Cji   3d DFT, and exchange 8 quater

      mem_size = (hkl_max+1)* num_hkl * (last_y - first_y + 1) 
      allocate(fft3d(mem_size), stat = alloc_stat)
      mem_fft3d = dble(8 * mem_size) 
      if(alloc_stat .gt. 0) then
         call error_stop (progname, subname,
     +        '3D density fft map memory allocation failed')
      endif
      mem_total = mem_total + mem_fft3d
      mem_peak  = max(mem_peak, mem_total)
      
Cji   FFT3D, (X,Y,Z) real -> (H,K,Z) 
Cji   complex(0:Hmax, Kmin:Kmax, Z_slab Zmin:Zmax)
Cji   because I change intlz_params.f to make 
Cji   -hkl_min = hkl_max = nfc_2d_row = nfc_2d_col

      do i = 0, last_y - first_y
         center(1) = (npix_row-1)/2.0
         center(2) = (npix_col-1)/2.0
         call fft_2dfft(map3d(i*npix_col*npix_row+1), 
     +        npix_row, npix_col, center,
     +        nrffta_omega, rffta_omega, nrffta_row, nrffta_col, 
     +        hkl_max, hkl_max, FFT3D(i*(hkl_max+1)*num_hkl+1))
      enddo

      deallocate(map3d)
      mem_total = mem_total - mem_map3d
      call mpi_barrier(mpi_comm_world, mpi_err)

Cji need exchange data between nodes from Z_slab to H_slab

      if (num_nodes.gt.1) then

         mem_size = (hkl_max+1)*num_hkl*(last_y - first_y + 1)
         allocate(fft_klh(mem_size), stat = alloc_stat)
         if(alloc_stat .gt. 0) then
            call error_stop (progname, subname,
     +           '3D density fft exchange memory 1 allocation failed')
         endif
         mem_total = mem_total + 8*mem_size 
         mem_peak  = max(mem_peak, mem_total)

         call arrange_3d_1(FFT3D, fft_klh, hkl_min, hkl_max)

         deallocate(fft3d)
         mem_total = mem_total - mem_fft3d
         mem_fft3d = 8 * mem_size
         
         mem_size = (last_iq-first_iq+1)*num_hkl*npix_row
         allocate(fft3d(mem_size), stat = alloc_stat)
         if(alloc_stat .gt. 0) then
            call error_stop (progname, subname,
     +           '3D density fft exchange memory 2 allocation failed')
         endif
         mem_total = mem_total + 8*mem_size 
         mem_peak  = max(mem_peak, mem_total)
         
         call exch_3d_1(fft_klh, hkl_min, hkl_max, FFT3D, npix_row)

         deallocate(fft_klh)
         mem_total = mem_total - mem_fft3d
         mem_fft3d = 8 * mem_size
         
      endif

Cji   1D fft, (H,K,Z)-->(K,L,H) complex(Kmin:Kmax, Lmin:Lmax, H_slab 0:Hmax)

      if (first) then
         mem_size = (last_iq-first_iq+1)* num_hkl**2
         allocate(f_hkl_1(mem_size), stat = alloc_stat)
         if(alloc_stat .gt. 0) then
            call error_stop (progname, subname,
     +           '3D density fft 1dfft allocation failed')
         endif
         mem_total = mem_total +8*mem_size 
         mem_peak  = max(mem_peak, mem_total)

         CALL cfft_1d(FFT3D, f_hkl_1, hkl_min, hkl_max, npix_row,
     +        nrffta_omega, rffta_omega)

         deallocate(fft3d)
         mem_total = mem_total - mem_fft3d
         mem_fft3d = 8 * mem_size
         
         first = .false.
         in_3d_name = fileodd
         goto 400

      else
         mem_size = (last_iq-first_iq+1)* num_hkl**2
         allocate(f_hkl_2(mem_size), stat = alloc_stat)
         if(alloc_stat .gt. 0) then
            call error_stop (progname, subname,
     +           '3D density fft 1dfft allocation failed')
         endif
         mem_total = mem_total +8*mem_size
         mem_peak  = max(mem_peak, mem_total)
         
         CALL cfft_1d(FFT3D, f_hkl_2, hkl_min, hkl_max, npix_row,
     +        nrffta_omega, rffta_omega)

         deallocate(fft3d)
         mem_total = mem_total - mem_fft3d
         mem_fft3d = 8 * mem_size
      endif

      call mpi_barrier(mpi_comm_world, mpi_err)
      t1 = wtime()
      t_3dfft = t1 - t2

C     **********************************************************************
C     *             computer the s_factor                                  *
C     **********************************************************************
      call comp_sfactor(iam, f_hkl_1, f_hkl_2, hkl_max, 
     +     first_iq, last_iq, res_max, res_min,
     +     nrffta_row, PIXSIZ_OUT, Nangle, mem_cmpt_intrps)

      mem_peak  = max(mem_peak, mem_total+mem_cmpt_intrps)
      deallocate(f_hkl_1, f_hkl_2)
      mem_total = mem_total - 2 * mem_fft3d 
      call mpi_barrier(mpi_comm_world, mpi_err)
      t2 = wtime()
      t_interp = t2 - t1
      
C     **********************************************************************

      if (mem_total .ne. 0) print *,'mem_total=',mem_total,
     +     'At the end, mem_total should be 0!!!'

      if ( iam .eq. 0 ) then
C     Print timing message.

         time = t_init + t_3dfft + t_interp

         if (test_time)
     +        print 40, iam, t_init,
     +        t_3dfft,
     +        t_interp,
     +        time
 40      format (/ 'Node ', i3,
     +        ' Time used in initialization                      =',
     +        f15.4, ' ' / 8x,
     +        ' Time used in read map & 3DFFT                    =',
     +        f15.4, ' ' / 8x,
     +        ' Time used in compute the factors                 =',
     +        f15.4, ' ' / 8x,
     +        ' Total time used                                  =',
     +        f15.4)
         
C     Print memory allocating message.

         if (test_memory) print 60, iam, mem_peak,
     +        mem_map3d, mem_fft3d,mem_cmpt_intrps
 60      format(/ 'Node ', i3, ' Memory allocation in BYTES:', /
     +        8x, ' Peak memory allocated   =', f18.1 /
     +        8x, ' Memory for 3D Map       =', f18.1 /
     +        8x, ' Memory for 3D FFT       =', f18.1 /
     +        8x, ' Memory used in CMPCC    =', f18.1 )
         
         print *, '**********finished nicely**********'
      endif

      call MPI_FINALIZE ( mpi_err )
      
      stop
      end program P3Dsf
